# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetLicensingSubscriptionSubscriptionsComplianceStatusesResult',
    'AwaitableGetLicensingSubscriptionSubscriptionsComplianceStatusesResult',
    'get_licensing_subscription_subscriptions_compliance_statuses',
    'get_licensing_subscription_subscriptions_compliance_statuses_output',
]

@pulumi.output_type
class GetLicensingSubscriptionSubscriptionsComplianceStatusesResult:
    """
    A collection of values returned by getLicensingSubscriptionSubscriptionsComplianceStatuses.
    """
    def __init__(__self__, id=None, items=None, organization_ids=None, subscription_ids=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if organization_ids and not isinstance(organization_ids, list):
            raise TypeError("Expected argument 'organization_ids' to be a list")
        pulumi.set(__self__, "organization_ids", organization_ids)
        if subscription_ids and not isinstance(subscription_ids, list):
            raise TypeError("Expected argument 'subscription_ids' to be a list")
        pulumi.set(__self__, "subscription_ids", subscription_ids)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetLicensingSubscriptionSubscriptionsComplianceStatusesItemResult']:
        """
        Array of ResponseLicensingGetAdministeredLicensingSubscriptionSubscriptionsComplianceStatuses
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="organizationIds")
    def organization_ids(self) -> Optional[Sequence[str]]:
        """
        organizationIds query parameter. Organizations to get subscription compliance information for
        """
        return pulumi.get(self, "organization_ids")

    @property
    @pulumi.getter(name="subscriptionIds")
    def subscription_ids(self) -> Optional[Sequence[str]]:
        """
        subscriptionIds query parameter. Subscription ids
        """
        return pulumi.get(self, "subscription_ids")


class AwaitableGetLicensingSubscriptionSubscriptionsComplianceStatusesResult(GetLicensingSubscriptionSubscriptionsComplianceStatusesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetLicensingSubscriptionSubscriptionsComplianceStatusesResult(
            id=self.id,
            items=self.items,
            organization_ids=self.organization_ids,
            subscription_ids=self.subscription_ids)


def get_licensing_subscription_subscriptions_compliance_statuses(organization_ids: Optional[Sequence[str]] = None,
                                                                 subscription_ids: Optional[Sequence[str]] = None,
                                                                 opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetLicensingSubscriptionSubscriptionsComplianceStatusesResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.administered.get_licensing_subscription_subscriptions_compliance_statuses(organization_ids=["string"],
        subscription_ids=["string"])
    pulumi.export("merakiAdministeredLicensingSubscriptionSubscriptionsComplianceStatusesExample", example.items)
    ```


    :param Sequence[str] organization_ids: organizationIds query parameter. Organizations to get subscription compliance information for
    :param Sequence[str] subscription_ids: subscriptionIds query parameter. Subscription ids
    """
    __args__ = dict()
    __args__['organizationIds'] = organization_ids
    __args__['subscriptionIds'] = subscription_ids
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:administered/getLicensingSubscriptionSubscriptionsComplianceStatuses:getLicensingSubscriptionSubscriptionsComplianceStatuses', __args__, opts=opts, typ=GetLicensingSubscriptionSubscriptionsComplianceStatusesResult).value

    return AwaitableGetLicensingSubscriptionSubscriptionsComplianceStatusesResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        organization_ids=pulumi.get(__ret__, 'organization_ids'),
        subscription_ids=pulumi.get(__ret__, 'subscription_ids'))


@_utilities.lift_output_func(get_licensing_subscription_subscriptions_compliance_statuses)
def get_licensing_subscription_subscriptions_compliance_statuses_output(organization_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                                        subscription_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                                        opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetLicensingSubscriptionSubscriptionsComplianceStatusesResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.administered.get_licensing_subscription_subscriptions_compliance_statuses(organization_ids=["string"],
        subscription_ids=["string"])
    pulumi.export("merakiAdministeredLicensingSubscriptionSubscriptionsComplianceStatusesExample", example.items)
    ```


    :param Sequence[str] organization_ids: organizationIds query parameter. Organizations to get subscription compliance information for
    :param Sequence[str] subscription_ids: subscriptionIds query parameter. Subscription ids
    """
    ...
