# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSwitchPortsStatusesResult',
    'AwaitableGetSwitchPortsStatusesResult',
    'get_switch_ports_statuses',
    'get_switch_ports_statuses_output',
]

@pulumi.output_type
class GetSwitchPortsStatusesResult:
    """
    A collection of values returned by getSwitchPortsStatuses.
    """
    def __init__(__self__, id=None, items=None, serial=None, t0=None, timespan=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if serial and not isinstance(serial, str):
            raise TypeError("Expected argument 'serial' to be a str")
        pulumi.set(__self__, "serial", serial)
        if t0 and not isinstance(t0, str):
            raise TypeError("Expected argument 't0' to be a str")
        pulumi.set(__self__, "t0", t0)
        if timespan and not isinstance(timespan, float):
            raise TypeError("Expected argument 'timespan' to be a float")
        pulumi.set(__self__, "timespan", timespan)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetSwitchPortsStatusesItemResult']:
        """
        Array of ResponseSwitchGetDeviceSwitchPortsStatuses
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def serial(self) -> str:
        """
        serial path parameter.
        """
        return pulumi.get(self, "serial")

    @property
    @pulumi.getter
    def t0(self) -> Optional[str]:
        """
        t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 31 days from today.
        """
        return pulumi.get(self, "t0")

    @property
    @pulumi.getter
    def timespan(self) -> Optional[float]:
        """
        timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameter t0. The value must be in seconds and be less than or equal to 31 days. The default is 1 day.
        """
        return pulumi.get(self, "timespan")


class AwaitableGetSwitchPortsStatusesResult(GetSwitchPortsStatusesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSwitchPortsStatusesResult(
            id=self.id,
            items=self.items,
            serial=self.serial,
            t0=self.t0,
            timespan=self.timespan)


def get_switch_ports_statuses(serial: Optional[str] = None,
                              t0: Optional[str] = None,
                              timespan: Optional[float] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSwitchPortsStatusesResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_switch_ports_statuses(serial="string",
        t0="string",
        timespan=1)
    pulumi.export("merakiDevicesSwitchPortsStatusesExample", example.items)
    ```


    :param str serial: serial path parameter.
    :param str t0: t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 31 days from today.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameter t0. The value must be in seconds and be less than or equal to 31 days. The default is 1 day.
    """
    __args__ = dict()
    __args__['serial'] = serial
    __args__['t0'] = t0
    __args__['timespan'] = timespan
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:devices/getSwitchPortsStatuses:getSwitchPortsStatuses', __args__, opts=opts, typ=GetSwitchPortsStatusesResult).value

    return AwaitableGetSwitchPortsStatusesResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        serial=pulumi.get(__ret__, 'serial'),
        t0=pulumi.get(__ret__, 't0'),
        timespan=pulumi.get(__ret__, 'timespan'))


@_utilities.lift_output_func(get_switch_ports_statuses)
def get_switch_ports_statuses_output(serial: Optional[pulumi.Input[str]] = None,
                                     t0: Optional[pulumi.Input[Optional[str]]] = None,
                                     timespan: Optional[pulumi.Input[Optional[float]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSwitchPortsStatusesResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.devices.get_switch_ports_statuses(serial="string",
        t0="string",
        timespan=1)
    pulumi.export("merakiDevicesSwitchPortsStatusesExample", example.items)
    ```


    :param str serial: serial path parameter.
    :param str t0: t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 31 days from today.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameter t0. The value must be in seconds and be less than or equal to 31 days. The default is 1 day.
    """
    ...
