# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['WirelessEthernetPortsProfilesArgs', 'WirelessEthernetPortsProfiles']

@pulumi.input_type
class WirelessEthernetPortsProfilesArgs:
    def __init__(__self__, *,
                 network_id: pulumi.Input[str],
                 profile_id: pulumi.Input[str],
                 name: Optional[pulumi.Input[str]] = None,
                 ports: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]] = None,
                 usb_ports: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]] = None):
        """
        The set of arguments for constructing a WirelessEthernetPortsProfiles resource.
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[str] profile_id: AP port profile ID
        :param pulumi.Input[str] name: AP port profile name
        :param pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]] ports: Ports config
        :param pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]] usb_ports: Usb ports config
        """
        pulumi.set(__self__, "network_id", network_id)
        pulumi.set(__self__, "profile_id", profile_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if ports is not None:
            pulumi.set(__self__, "ports", ports)
        if usb_ports is not None:
            pulumi.set(__self__, "usb_ports", usb_ports)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Input[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter(name="profileId")
    def profile_id(self) -> pulumi.Input[str]:
        """
        AP port profile ID
        """
        return pulumi.get(self, "profile_id")

    @profile_id.setter
    def profile_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "profile_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        AP port profile name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def ports(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]]:
        """
        Ports config
        """
        return pulumi.get(self, "ports")

    @ports.setter
    def ports(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]]):
        pulumi.set(self, "ports", value)

    @property
    @pulumi.getter(name="usbPorts")
    def usb_ports(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]]:
        """
        Usb ports config
        """
        return pulumi.get(self, "usb_ports")

    @usb_ports.setter
    def usb_ports(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]]):
        pulumi.set(self, "usb_ports", value)


@pulumi.input_type
class _WirelessEthernetPortsProfilesState:
    def __init__(__self__, *,
                 is_default: Optional[pulumi.Input[bool]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 ports: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]] = None,
                 profile_id: Optional[pulumi.Input[str]] = None,
                 usb_ports: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]] = None):
        """
        Input properties used for looking up and filtering WirelessEthernetPortsProfiles resources.
        :param pulumi.Input[bool] is_default: Is default profile
        :param pulumi.Input[str] name: AP port profile name
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]] ports: Ports config
        :param pulumi.Input[str] profile_id: AP port profile ID
        :param pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]] usb_ports: Usb ports config
        """
        if is_default is not None:
            pulumi.set(__self__, "is_default", is_default)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if network_id is not None:
            pulumi.set(__self__, "network_id", network_id)
        if ports is not None:
            pulumi.set(__self__, "ports", ports)
        if profile_id is not None:
            pulumi.set(__self__, "profile_id", profile_id)
        if usb_ports is not None:
            pulumi.set(__self__, "usb_ports", usb_ports)

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> Optional[pulumi.Input[bool]]:
        """
        Is default profile
        """
        return pulumi.get(self, "is_default")

    @is_default.setter
    def is_default(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_default", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        AP port profile name
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> Optional[pulumi.Input[str]]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @network_id.setter
    def network_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "network_id", value)

    @property
    @pulumi.getter
    def ports(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]]:
        """
        Ports config
        """
        return pulumi.get(self, "ports")

    @ports.setter
    def ports(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesPortArgs']]]]):
        pulumi.set(self, "ports", value)

    @property
    @pulumi.getter(name="profileId")
    def profile_id(self) -> Optional[pulumi.Input[str]]:
        """
        AP port profile ID
        """
        return pulumi.get(self, "profile_id")

    @profile_id.setter
    def profile_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "profile_id", value)

    @property
    @pulumi.getter(name="usbPorts")
    def usb_ports(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]]:
        """
        Usb ports config
        """
        return pulumi.get(self, "usb_ports")

    @usb_ports.setter
    def usb_ports(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WirelessEthernetPortsProfilesUsbPortArgs']]]]):
        pulumi.set(self, "usb_ports", value)


class WirelessEthernetPortsProfiles(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesPortArgs', 'WirelessEthernetPortsProfilesPortArgsDict']]]]] = None,
                 profile_id: Optional[pulumi.Input[str]] = None,
                 usb_ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesUsbPortArgs', 'WirelessEthernetPortsProfilesUsbPortArgsDict']]]]] = None,
                 __props__=None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessEthernetPortsProfiles:WirelessEthernetPortsProfiles example "network_id,profile_id"
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: AP port profile name
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesPortArgs', 'WirelessEthernetPortsProfilesPortArgsDict']]]] ports: Ports config
        :param pulumi.Input[str] profile_id: AP port profile ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesUsbPortArgs', 'WirelessEthernetPortsProfilesUsbPortArgsDict']]]] usb_ports: Usb ports config
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: WirelessEthernetPortsProfilesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        ## Import

        ```sh
        $ pulumi import meraki:networks/wirelessEthernetPortsProfiles:WirelessEthernetPortsProfiles example "network_id,profile_id"
        ```

        :param str resource_name: The name of the resource.
        :param WirelessEthernetPortsProfilesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WirelessEthernetPortsProfilesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 network_id: Optional[pulumi.Input[str]] = None,
                 ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesPortArgs', 'WirelessEthernetPortsProfilesPortArgsDict']]]]] = None,
                 profile_id: Optional[pulumi.Input[str]] = None,
                 usb_ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesUsbPortArgs', 'WirelessEthernetPortsProfilesUsbPortArgsDict']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WirelessEthernetPortsProfilesArgs.__new__(WirelessEthernetPortsProfilesArgs)

            __props__.__dict__["name"] = name
            if network_id is None and not opts.urn:
                raise TypeError("Missing required property 'network_id'")
            __props__.__dict__["network_id"] = network_id
            __props__.__dict__["ports"] = ports
            if profile_id is None and not opts.urn:
                raise TypeError("Missing required property 'profile_id'")
            __props__.__dict__["profile_id"] = profile_id
            __props__.__dict__["usb_ports"] = usb_ports
            __props__.__dict__["is_default"] = None
        super(WirelessEthernetPortsProfiles, __self__).__init__(
            'meraki:networks/wirelessEthernetPortsProfiles:WirelessEthernetPortsProfiles',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            is_default: Optional[pulumi.Input[bool]] = None,
            name: Optional[pulumi.Input[str]] = None,
            network_id: Optional[pulumi.Input[str]] = None,
            ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesPortArgs', 'WirelessEthernetPortsProfilesPortArgsDict']]]]] = None,
            profile_id: Optional[pulumi.Input[str]] = None,
            usb_ports: Optional[pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesUsbPortArgs', 'WirelessEthernetPortsProfilesUsbPortArgsDict']]]]] = None) -> 'WirelessEthernetPortsProfiles':
        """
        Get an existing WirelessEthernetPortsProfiles resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] is_default: Is default profile
        :param pulumi.Input[str] name: AP port profile name
        :param pulumi.Input[str] network_id: networkId path parameter. Network ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesPortArgs', 'WirelessEthernetPortsProfilesPortArgsDict']]]] ports: Ports config
        :param pulumi.Input[str] profile_id: AP port profile ID
        :param pulumi.Input[Sequence[pulumi.Input[Union['WirelessEthernetPortsProfilesUsbPortArgs', 'WirelessEthernetPortsProfilesUsbPortArgsDict']]]] usb_ports: Usb ports config
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WirelessEthernetPortsProfilesState.__new__(_WirelessEthernetPortsProfilesState)

        __props__.__dict__["is_default"] = is_default
        __props__.__dict__["name"] = name
        __props__.__dict__["network_id"] = network_id
        __props__.__dict__["ports"] = ports
        __props__.__dict__["profile_id"] = profile_id
        __props__.__dict__["usb_ports"] = usb_ports
        return WirelessEthernetPortsProfiles(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> pulumi.Output[bool]:
        """
        Is default profile
        """
        return pulumi.get(self, "is_default")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        AP port profile name
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="networkId")
    def network_id(self) -> pulumi.Output[str]:
        """
        networkId path parameter. Network ID
        """
        return pulumi.get(self, "network_id")

    @property
    @pulumi.getter
    def ports(self) -> pulumi.Output[Sequence['outputs.WirelessEthernetPortsProfilesPort']]:
        """
        Ports config
        """
        return pulumi.get(self, "ports")

    @property
    @pulumi.getter(name="profileId")
    def profile_id(self) -> pulumi.Output[str]:
        """
        AP port profile ID
        """
        return pulumi.get(self, "profile_id")

    @property
    @pulumi.getter(name="usbPorts")
    def usb_ports(self) -> pulumi.Output[Sequence['outputs.WirelessEthernetPortsProfilesUsbPort']]:
        """
        Usb ports config
        """
        return pulumi.get(self, "usb_ports")

