# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDevicesBootsHistoryResult',
    'AwaitableGetDevicesBootsHistoryResult',
    'get_devices_boots_history',
    'get_devices_boots_history_output',
]

@pulumi.output_type
class GetDevicesBootsHistoryResult:
    """
    A collection of values returned by getDevicesBootsHistory.
    """
    def __init__(__self__, ending_before=None, id=None, items=None, most_recent_per_device=None, organization_id=None, per_page=None, serials=None, sort_order=None, starting_after=None, t0=None, t1=None, timespan=None):
        if ending_before and not isinstance(ending_before, str):
            raise TypeError("Expected argument 'ending_before' to be a str")
        pulumi.set(__self__, "ending_before", ending_before)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if most_recent_per_device and not isinstance(most_recent_per_device, bool):
            raise TypeError("Expected argument 'most_recent_per_device' to be a bool")
        pulumi.set(__self__, "most_recent_per_device", most_recent_per_device)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if per_page and not isinstance(per_page, int):
            raise TypeError("Expected argument 'per_page' to be a int")
        pulumi.set(__self__, "per_page", per_page)
        if serials and not isinstance(serials, list):
            raise TypeError("Expected argument 'serials' to be a list")
        pulumi.set(__self__, "serials", serials)
        if sort_order and not isinstance(sort_order, str):
            raise TypeError("Expected argument 'sort_order' to be a str")
        pulumi.set(__self__, "sort_order", sort_order)
        if starting_after and not isinstance(starting_after, str):
            raise TypeError("Expected argument 'starting_after' to be a str")
        pulumi.set(__self__, "starting_after", starting_after)
        if t0 and not isinstance(t0, str):
            raise TypeError("Expected argument 't0' to be a str")
        pulumi.set(__self__, "t0", t0)
        if t1 and not isinstance(t1, str):
            raise TypeError("Expected argument 't1' to be a str")
        pulumi.set(__self__, "t1", t1)
        if timespan and not isinstance(timespan, float):
            raise TypeError("Expected argument 'timespan' to be a float")
        pulumi.set(__self__, "timespan", timespan)

    @property
    @pulumi.getter(name="endingBefore")
    def ending_before(self) -> Optional[str]:
        """
        endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "ending_before")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetDevicesBootsHistoryItemResult']:
        """
        Array of ResponseOrganizationsGetOrganizationDevicesBootsHistory
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="mostRecentPerDevice")
    def most_recent_per_device(self) -> Optional[bool]:
        """
        mostRecentPerDevice query parameter. If true, only the most recent boot for each device is returned.
        """
        return pulumi.get(self, "most_recent_per_device")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        organizationId path parameter. Organization ID
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="perPage")
    def per_page(self) -> Optional[int]:
        """
        perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
        """
        return pulumi.get(self, "per_page")

    @property
    @pulumi.getter
    def serials(self) -> Optional[Sequence[str]]:
        """
        serials query parameter. Optional parameter to filter device by device serial numbers. This filter uses multiple exact matches.
        """
        return pulumi.get(self, "serials")

    @property
    @pulumi.getter(name="sortOrder")
    def sort_order(self) -> Optional[str]:
        """
        sortOrder query parameter. Sorted order of entries. Order options are 'ascending' and 'descending'. Default is 'descending'.
        """
        return pulumi.get(self, "sort_order")

    @property
    @pulumi.getter(name="startingAfter")
    def starting_after(self) -> Optional[str]:
        """
        startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "starting_after")

    @property
    @pulumi.getter
    def t0(self) -> Optional[str]:
        """
        t0 query parameter. The beginning of the timespan for the data.
        """
        return pulumi.get(self, "t0")

    @property
    @pulumi.getter
    def t1(self) -> Optional[str]:
        """
        t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 730 days after t0.
        """
        return pulumi.get(self, "t1")

    @property
    @pulumi.getter
    def timespan(self) -> Optional[float]:
        """
        timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be less than or equal to 730 days.
        """
        return pulumi.get(self, "timespan")


class AwaitableGetDevicesBootsHistoryResult(GetDevicesBootsHistoryResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDevicesBootsHistoryResult(
            ending_before=self.ending_before,
            id=self.id,
            items=self.items,
            most_recent_per_device=self.most_recent_per_device,
            organization_id=self.organization_id,
            per_page=self.per_page,
            serials=self.serials,
            sort_order=self.sort_order,
            starting_after=self.starting_after,
            t0=self.t0,
            t1=self.t1,
            timespan=self.timespan)


def get_devices_boots_history(ending_before: Optional[str] = None,
                              most_recent_per_device: Optional[bool] = None,
                              organization_id: Optional[str] = None,
                              per_page: Optional[int] = None,
                              serials: Optional[Sequence[str]] = None,
                              sort_order: Optional[str] = None,
                              starting_after: Optional[str] = None,
                              t0: Optional[str] = None,
                              t1: Optional[str] = None,
                              timespan: Optional[float] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDevicesBootsHistoryResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_devices_boots_history(ending_before="string",
        most_recent_per_device=False,
        organization_id="string",
        per_page=1,
        serials=["string"],
        sort_order="string",
        starting_after="string",
        t0="string",
        t1="string",
        timespan=1)
    pulumi.export("merakiOrganizationsDevicesBootsHistoryExample", example.items)
    ```


    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param bool most_recent_per_device: mostRecentPerDevice query parameter. If true, only the most recent boot for each device is returned.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
    :param Sequence[str] serials: serials query parameter. Optional parameter to filter device by device serial numbers. This filter uses multiple exact matches.
    :param str sort_order: sortOrder query parameter. Sorted order of entries. Order options are 'ascending' and 'descending'. Default is 'descending'.
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str t0: t0 query parameter. The beginning of the timespan for the data.
    :param str t1: t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 730 days after t0.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be less than or equal to 730 days.
    """
    __args__ = dict()
    __args__['endingBefore'] = ending_before
    __args__['mostRecentPerDevice'] = most_recent_per_device
    __args__['organizationId'] = organization_id
    __args__['perPage'] = per_page
    __args__['serials'] = serials
    __args__['sortOrder'] = sort_order
    __args__['startingAfter'] = starting_after
    __args__['t0'] = t0
    __args__['t1'] = t1
    __args__['timespan'] = timespan
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:organizations/getDevicesBootsHistory:getDevicesBootsHistory', __args__, opts=opts, typ=GetDevicesBootsHistoryResult).value

    return AwaitableGetDevicesBootsHistoryResult(
        ending_before=pulumi.get(__ret__, 'ending_before'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        most_recent_per_device=pulumi.get(__ret__, 'most_recent_per_device'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        per_page=pulumi.get(__ret__, 'per_page'),
        serials=pulumi.get(__ret__, 'serials'),
        sort_order=pulumi.get(__ret__, 'sort_order'),
        starting_after=pulumi.get(__ret__, 'starting_after'),
        t0=pulumi.get(__ret__, 't0'),
        t1=pulumi.get(__ret__, 't1'),
        timespan=pulumi.get(__ret__, 'timespan'))


@_utilities.lift_output_func(get_devices_boots_history)
def get_devices_boots_history_output(ending_before: Optional[pulumi.Input[Optional[str]]] = None,
                                     most_recent_per_device: Optional[pulumi.Input[Optional[bool]]] = None,
                                     organization_id: Optional[pulumi.Input[str]] = None,
                                     per_page: Optional[pulumi.Input[Optional[int]]] = None,
                                     serials: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                     sort_order: Optional[pulumi.Input[Optional[str]]] = None,
                                     starting_after: Optional[pulumi.Input[Optional[str]]] = None,
                                     t0: Optional[pulumi.Input[Optional[str]]] = None,
                                     t1: Optional[pulumi.Input[Optional[str]]] = None,
                                     timespan: Optional[pulumi.Input[Optional[float]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDevicesBootsHistoryResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_devices_boots_history(ending_before="string",
        most_recent_per_device=False,
        organization_id="string",
        per_page=1,
        serials=["string"],
        sort_order="string",
        starting_after="string",
        t0="string",
        t1="string",
        timespan=1)
    pulumi.export("merakiOrganizationsDevicesBootsHistoryExample", example.items)
    ```


    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param bool most_recent_per_device: mostRecentPerDevice query parameter. If true, only the most recent boot for each device is returned.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
    :param Sequence[str] serials: serials query parameter. Optional parameter to filter device by device serial numbers. This filter uses multiple exact matches.
    :param str sort_order: sortOrder query parameter. Sorted order of entries. Order options are 'ascending' and 'descending'. Default is 'descending'.
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str t0: t0 query parameter. The beginning of the timespan for the data.
    :param str t1: t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 730 days after t0.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be less than or equal to 730 days.
    """
    ...
