# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetWirelessDevicesPacketLossByClientResult',
    'AwaitableGetWirelessDevicesPacketLossByClientResult',
    'get_wireless_devices_packet_loss_by_client',
    'get_wireless_devices_packet_loss_by_client_output',
]

@pulumi.output_type
class GetWirelessDevicesPacketLossByClientResult:
    """
    A collection of values returned by getWirelessDevicesPacketLossByClient.
    """
    def __init__(__self__, bands=None, ending_before=None, id=None, items=None, macs=None, network_ids=None, organization_id=None, per_page=None, ssids=None, starting_after=None, t0=None, t1=None, timespan=None):
        if bands and not isinstance(bands, list):
            raise TypeError("Expected argument 'bands' to be a list")
        pulumi.set(__self__, "bands", bands)
        if ending_before and not isinstance(ending_before, str):
            raise TypeError("Expected argument 'ending_before' to be a str")
        pulumi.set(__self__, "ending_before", ending_before)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if macs and not isinstance(macs, list):
            raise TypeError("Expected argument 'macs' to be a list")
        pulumi.set(__self__, "macs", macs)
        if network_ids and not isinstance(network_ids, list):
            raise TypeError("Expected argument 'network_ids' to be a list")
        pulumi.set(__self__, "network_ids", network_ids)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if per_page and not isinstance(per_page, int):
            raise TypeError("Expected argument 'per_page' to be a int")
        pulumi.set(__self__, "per_page", per_page)
        if ssids and not isinstance(ssids, list):
            raise TypeError("Expected argument 'ssids' to be a list")
        pulumi.set(__self__, "ssids", ssids)
        if starting_after and not isinstance(starting_after, str):
            raise TypeError("Expected argument 'starting_after' to be a str")
        pulumi.set(__self__, "starting_after", starting_after)
        if t0 and not isinstance(t0, str):
            raise TypeError("Expected argument 't0' to be a str")
        pulumi.set(__self__, "t0", t0)
        if t1 and not isinstance(t1, str):
            raise TypeError("Expected argument 't1' to be a str")
        pulumi.set(__self__, "t1", t1)
        if timespan and not isinstance(timespan, float):
            raise TypeError("Expected argument 'timespan' to be a float")
        pulumi.set(__self__, "timespan", timespan)

    @property
    @pulumi.getter
    def bands(self) -> Optional[Sequence[str]]:
        """
        bands query parameter. Filter results by band. Valid bands are: 2.4, 5, and 6.
        """
        return pulumi.get(self, "bands")

    @property
    @pulumi.getter(name="endingBefore")
    def ending_before(self) -> Optional[str]:
        """
        endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "ending_before")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetWirelessDevicesPacketLossByClientItemResult']:
        """
        Array of ResponseWirelessGetOrganizationWirelessDevicesPacketLossByClient
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def macs(self) -> Optional[Sequence[str]]:
        """
        macs query parameter. Filter results by client mac address(es).
        """
        return pulumi.get(self, "macs")

    @property
    @pulumi.getter(name="networkIds")
    def network_ids(self) -> Optional[Sequence[str]]:
        """
        networkIds query parameter. Filter results by network.
        """
        return pulumi.get(self, "network_ids")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        organizationId path parameter. Organization ID
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter(name="perPage")
    def per_page(self) -> Optional[int]:
        """
        perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
        """
        return pulumi.get(self, "per_page")

    @property
    @pulumi.getter
    def ssids(self) -> Optional[Sequence[str]]:
        """
        ssids query parameter. Filter results by SSID number.
        """
        return pulumi.get(self, "ssids")

    @property
    @pulumi.getter(name="startingAfter")
    def starting_after(self) -> Optional[str]:
        """
        startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
        """
        return pulumi.get(self, "starting_after")

    @property
    @pulumi.getter
    def t0(self) -> Optional[str]:
        """
        t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 90 days from today.
        """
        return pulumi.get(self, "t0")

    @property
    @pulumi.getter
    def t1(self) -> Optional[str]:
        """
        t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 90 days after t0.
        """
        return pulumi.get(self, "t1")

    @property
    @pulumi.getter
    def timespan(self) -> Optional[float]:
        """
        timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be greater than or equal to 5 minutes and be less than or equal to 90 days. The default is 7 days.
        """
        return pulumi.get(self, "timespan")


class AwaitableGetWirelessDevicesPacketLossByClientResult(GetWirelessDevicesPacketLossByClientResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWirelessDevicesPacketLossByClientResult(
            bands=self.bands,
            ending_before=self.ending_before,
            id=self.id,
            items=self.items,
            macs=self.macs,
            network_ids=self.network_ids,
            organization_id=self.organization_id,
            per_page=self.per_page,
            ssids=self.ssids,
            starting_after=self.starting_after,
            t0=self.t0,
            t1=self.t1,
            timespan=self.timespan)


def get_wireless_devices_packet_loss_by_client(bands: Optional[Sequence[str]] = None,
                                               ending_before: Optional[str] = None,
                                               macs: Optional[Sequence[str]] = None,
                                               network_ids: Optional[Sequence[str]] = None,
                                               organization_id: Optional[str] = None,
                                               per_page: Optional[int] = None,
                                               ssids: Optional[Sequence[str]] = None,
                                               starting_after: Optional[str] = None,
                                               t0: Optional[str] = None,
                                               t1: Optional[str] = None,
                                               timespan: Optional[float] = None,
                                               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWirelessDevicesPacketLossByClientResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_wireless_devices_packet_loss_by_client(bands=["string"],
        ending_before="string",
        macs=["string"],
        network_ids=["string"],
        organization_id="string",
        per_page=1,
        ssids=["string"],
        starting_after="string",
        t0="string",
        t1="string",
        timespan=1)
    pulumi.export("merakiOrganizationsWirelessDevicesPacketLossByClientExample", example.items)
    ```


    :param Sequence[str] bands: bands query parameter. Filter results by band. Valid bands are: 2.4, 5, and 6.
    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param Sequence[str] macs: macs query parameter. Filter results by client mac address(es).
    :param Sequence[str] network_ids: networkIds query parameter. Filter results by network.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
    :param Sequence[str] ssids: ssids query parameter. Filter results by SSID number.
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str t0: t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 90 days from today.
    :param str t1: t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 90 days after t0.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be greater than or equal to 5 minutes and be less than or equal to 90 days. The default is 7 days.
    """
    __args__ = dict()
    __args__['bands'] = bands
    __args__['endingBefore'] = ending_before
    __args__['macs'] = macs
    __args__['networkIds'] = network_ids
    __args__['organizationId'] = organization_id
    __args__['perPage'] = per_page
    __args__['ssids'] = ssids
    __args__['startingAfter'] = starting_after
    __args__['t0'] = t0
    __args__['t1'] = t1
    __args__['timespan'] = timespan
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('meraki:organizations/getWirelessDevicesPacketLossByClient:getWirelessDevicesPacketLossByClient', __args__, opts=opts, typ=GetWirelessDevicesPacketLossByClientResult).value

    return AwaitableGetWirelessDevicesPacketLossByClientResult(
        bands=pulumi.get(__ret__, 'bands'),
        ending_before=pulumi.get(__ret__, 'ending_before'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        macs=pulumi.get(__ret__, 'macs'),
        network_ids=pulumi.get(__ret__, 'network_ids'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        per_page=pulumi.get(__ret__, 'per_page'),
        ssids=pulumi.get(__ret__, 'ssids'),
        starting_after=pulumi.get(__ret__, 'starting_after'),
        t0=pulumi.get(__ret__, 't0'),
        t1=pulumi.get(__ret__, 't1'),
        timespan=pulumi.get(__ret__, 'timespan'))


@_utilities.lift_output_func(get_wireless_devices_packet_loss_by_client)
def get_wireless_devices_packet_loss_by_client_output(bands: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                      ending_before: Optional[pulumi.Input[Optional[str]]] = None,
                                                      macs: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                      network_ids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                      organization_id: Optional[pulumi.Input[str]] = None,
                                                      per_page: Optional[pulumi.Input[Optional[int]]] = None,
                                                      ssids: Optional[pulumi.Input[Optional[Sequence[str]]]] = None,
                                                      starting_after: Optional[pulumi.Input[Optional[str]]] = None,
                                                      t0: Optional[pulumi.Input[Optional[str]]] = None,
                                                      t1: Optional[pulumi.Input[Optional[str]]] = None,
                                                      timespan: Optional[pulumi.Input[Optional[float]]] = None,
                                                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWirelessDevicesPacketLossByClientResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_meraki as meraki

    example = meraki.organizations.get_wireless_devices_packet_loss_by_client(bands=["string"],
        ending_before="string",
        macs=["string"],
        network_ids=["string"],
        organization_id="string",
        per_page=1,
        ssids=["string"],
        starting_after="string",
        t0="string",
        t1="string",
        timespan=1)
    pulumi.export("merakiOrganizationsWirelessDevicesPacketLossByClientExample", example.items)
    ```


    :param Sequence[str] bands: bands query parameter. Filter results by band. Valid bands are: 2.4, 5, and 6.
    :param str ending_before: endingBefore query parameter. A token used by the server to indicate the end of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param Sequence[str] macs: macs query parameter. Filter results by client mac address(es).
    :param Sequence[str] network_ids: networkIds query parameter. Filter results by network.
    :param str organization_id: organizationId path parameter. Organization ID
    :param int per_page: perPage query parameter. The number of entries per page returned. Acceptable range is 3 1000. Default is 1000.
    :param Sequence[str] ssids: ssids query parameter. Filter results by SSID number.
    :param str starting_after: startingAfter query parameter. A token used by the server to indicate the start of the page. Often this is a timestamp or an ID but it is not limited to those. This parameter should not be defined by client applications. The link for the first, last, prev, or next page in the HTTP Link header should define it.
    :param str t0: t0 query parameter. The beginning of the timespan for the data. The maximum lookback period is 90 days from today.
    :param str t1: t1 query parameter. The end of the timespan for the data. t1 can be a maximum of 90 days after t0.
    :param float timespan: timespan query parameter. The timespan for which the information will be fetched. If specifying timespan, do not specify parameters t0 and t1. The value must be in seconds and be greater than or equal to 5 minutes and be less than or equal to 90 days. The default is 7 days.
    """
    ...
