# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 meraki_base_url: Optional[pulumi.Input[str]] = None,
                 meraki_dashboard_api_key: Optional[pulumi.Input[str]] = None,
                 meraki_debug: Optional[pulumi.Input[str]] = None,
                 meraki_requests_per_second: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] meraki_base_url: Cisco Meraki base URL, FQDN or IP. If not set, it uses the MERAKI_BASE_URL environment variable. Default is
               (https://api.meraki.com/)
        :param pulumi.Input[str] meraki_dashboard_api_key: Cisco Meraki meraki_dashboard_api_key to authenticate. If not set, it uses the MERAKI_DASHBOARD_API_KEY environment
               variable.
        :param pulumi.Input[str] meraki_debug: Flag for Cisco Meraki to enable debugging. If not set, it uses the MERAKI_DEBUG environment variable defaults to
               `false`.
        :param pulumi.Input[int] meraki_requests_per_second: Flag requests per second allowed for client. Default is (10)
        """
        if meraki_base_url is not None:
            pulumi.set(__self__, "meraki_base_url", meraki_base_url)
        if meraki_dashboard_api_key is not None:
            pulumi.set(__self__, "meraki_dashboard_api_key", meraki_dashboard_api_key)
        if meraki_debug is not None:
            pulumi.set(__self__, "meraki_debug", meraki_debug)
        if meraki_requests_per_second is not None:
            pulumi.set(__self__, "meraki_requests_per_second", meraki_requests_per_second)

    @property
    @pulumi.getter(name="merakiBaseUrl")
    def meraki_base_url(self) -> Optional[pulumi.Input[str]]:
        """
        Cisco Meraki base URL, FQDN or IP. If not set, it uses the MERAKI_BASE_URL environment variable. Default is
        (https://api.meraki.com/)
        """
        return pulumi.get(self, "meraki_base_url")

    @meraki_base_url.setter
    def meraki_base_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "meraki_base_url", value)

    @property
    @pulumi.getter(name="merakiDashboardApiKey")
    def meraki_dashboard_api_key(self) -> Optional[pulumi.Input[str]]:
        """
        Cisco Meraki meraki_dashboard_api_key to authenticate. If not set, it uses the MERAKI_DASHBOARD_API_KEY environment
        variable.
        """
        return pulumi.get(self, "meraki_dashboard_api_key")

    @meraki_dashboard_api_key.setter
    def meraki_dashboard_api_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "meraki_dashboard_api_key", value)

    @property
    @pulumi.getter(name="merakiDebug")
    def meraki_debug(self) -> Optional[pulumi.Input[str]]:
        """
        Flag for Cisco Meraki to enable debugging. If not set, it uses the MERAKI_DEBUG environment variable defaults to
        `false`.
        """
        return pulumi.get(self, "meraki_debug")

    @meraki_debug.setter
    def meraki_debug(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "meraki_debug", value)

    @property
    @pulumi.getter(name="merakiRequestsPerSecond")
    def meraki_requests_per_second(self) -> Optional[pulumi.Input[int]]:
        """
        Flag requests per second allowed for client. Default is (10)
        """
        return pulumi.get(self, "meraki_requests_per_second")

    @meraki_requests_per_second.setter
    def meraki_requests_per_second(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "meraki_requests_per_second", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 meraki_base_url: Optional[pulumi.Input[str]] = None,
                 meraki_dashboard_api_key: Optional[pulumi.Input[str]] = None,
                 meraki_debug: Optional[pulumi.Input[str]] = None,
                 meraki_requests_per_second: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        The provider type for the meraki package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] meraki_base_url: Cisco Meraki base URL, FQDN or IP. If not set, it uses the MERAKI_BASE_URL environment variable. Default is
               (https://api.meraki.com/)
        :param pulumi.Input[str] meraki_dashboard_api_key: Cisco Meraki meraki_dashboard_api_key to authenticate. If not set, it uses the MERAKI_DASHBOARD_API_KEY environment
               variable.
        :param pulumi.Input[str] meraki_debug: Flag for Cisco Meraki to enable debugging. If not set, it uses the MERAKI_DEBUG environment variable defaults to
               `false`.
        :param pulumi.Input[int] meraki_requests_per_second: Flag requests per second allowed for client. Default is (10)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProviderArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the meraki package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 meraki_base_url: Optional[pulumi.Input[str]] = None,
                 meraki_dashboard_api_key: Optional[pulumi.Input[str]] = None,
                 meraki_debug: Optional[pulumi.Input[str]] = None,
                 meraki_requests_per_second: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["meraki_base_url"] = meraki_base_url
            __props__.__dict__["meraki_dashboard_api_key"] = None if meraki_dashboard_api_key is None else pulumi.Output.secret(meraki_dashboard_api_key)
            __props__.__dict__["meraki_debug"] = meraki_debug
            __props__.__dict__["meraki_requests_per_second"] = pulumi.Output.from_input(meraki_requests_per_second).apply(pulumi.runtime.to_json) if meraki_requests_per_second is not None else None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["merakiDashboardApiKey"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Provider, __self__).__init__(
            'meraki',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="merakiBaseUrl")
    def meraki_base_url(self) -> pulumi.Output[Optional[str]]:
        """
        Cisco Meraki base URL, FQDN or IP. If not set, it uses the MERAKI_BASE_URL environment variable. Default is
        (https://api.meraki.com/)
        """
        return pulumi.get(self, "meraki_base_url")

    @property
    @pulumi.getter(name="merakiDashboardApiKey")
    def meraki_dashboard_api_key(self) -> pulumi.Output[Optional[str]]:
        """
        Cisco Meraki meraki_dashboard_api_key to authenticate. If not set, it uses the MERAKI_DASHBOARD_API_KEY environment
        variable.
        """
        return pulumi.get(self, "meraki_dashboard_api_key")

    @property
    @pulumi.getter(name="merakiDebug")
    def meraki_debug(self) -> pulumi.Output[Optional[str]]:
        """
        Flag for Cisco Meraki to enable debugging. If not set, it uses the MERAKI_DEBUG environment variable defaults to
        `false`.
        """
        return pulumi.get(self, "meraki_debug")

